//             DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
//                    Version 2, December 2004
//
// Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>
//
// Everyone is permitted to copy and distribute verbatim or modified
// copies of this license document, and changing it is allowed as long
// as the name is changed.
//
//            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
//   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
//
//  0. You just DO WHAT THE FUCK YOU WANT TO.
//
// Author: zadig <thomas chr(0x40) bailleux.me>

use std;

/// Iterator for entries inside an OLE file.
///
/// See [Entry](Entry)
pub struct OLEIterator<'a, T: 'a>
  where T: std::io::Read {
  ole: &'a super::ole::Reader<T>,
  curr: usize
}

impl<'a, T> OLEIterator<'a, T>
  where T: std::io::Read {
  pub fn new(ole: &'a super::ole::Reader<T>) -> OLEIterator<'a, T> {
    OLEIterator {
      ole: ole,
      curr: 0
    }
  }
}

impl<'a, T> Iterator for OLEIterator<'a, T>
  where T: std::io::Read {
  type Item = &'a super::entry::Entry;

  fn next(&mut self) -> Option<&'a super::entry::Entry> {
    let entries = self.ole.entries.as_ref().unwrap();
    self.curr += 1;
    if self.curr < entries.len() {
      Some(&entries[self.curr])
    } else {
      None
    }
  }
}
